DECLARE SUB center (a$)
DECLARE SUB playsong ()
DECLARE SUB initsongpos ()
DECLARE SUB getblaster (DMA%, baseport%, IRQ%)
DECLARE SUB loadmem (datei$)
DECLARE FUNCTION getmaxch! (name$)
DECLARE SUB loadsong (name$)
DECLARE SUB warte (p#)
DECLARE SUB setins (achannel%)
DECLARE SUB closechannel (rchan%)
DECLARE SUB playnote (note$, channel%, oktave!)
DECLARE SUB sbinit ()
DECLARE SUB closechannels ()
DECLARE SUB WriteReg (Reg%, value%)
DIM SHARED cmult%, mmult%, clevel%, mlevel%, cattack%, mattack%
DIM SHARED csustain%, msustain%, waveform%, maxchannel AS INTEGER
DIM SHARED baseport%
'###################### Falls der Benutzer kein DMA angegeben hat ########
'###################### wird die BLASTER Variable ausgewertet.    ########
x$ = COMMAND$
c = VAL("&H" + x$)
baseport% = c: IF x$ = "" THEN getblaster DMA%, baseport%, IRQ%
TYPE domi
mmult AS INTEGER
cmult AS INTEGER
mlevel AS INTEGER
clevel AS INTEGER
mattack AS INTEGER
cattack AS INTEGER
msustain AS INTEGER
csustain AS INTEGER
END TYPE
channel = maxchannel: VIEW PRINT 1 TO 25
channel1 = 9
DIM SHARED TIME(channel1, 1000) AS SINGLE
DIM SHARED note(channel1, 1000) AS STRING * 2
DIM SHARED speed(channel1, 1000) AS SINGLE
DIM SHARED oktave(channel1, 1000) AS INTEGER
DIM SHARED maxnotes(channel1) AS INTEGER
DIM SHARED songpos(9) AS INTEGER, datei$, playing AS INTEGER
   sbinit                       'Bereitet SB vor / Initialisierung
   waveform% = 1
   playing = 1
'################# Here start's your Code #####################


CLS : INPUT ".MUS File to play:", file$



loadmem file$
DO
  playsong                      'Mu aufgerufen werden, um Song zu spielen
IF playing = 0 THEN playing = 1: ERASE songpos
LOOP UNTIL INKEY$ <> ""         'Mach solange weiter bis der USER 'nen
                                'Knopf drckt






'################## Here end's your Code ######################
closechannels                   'Schliet alle Kanle
sbinit                          'Gibt SB fr andere Programme wieder frei

SUB center (a$)
LOCATE , 40 - LEN(a$) / 2: PRINT a$
END SUB

SUB closechannel (rchan%)
WriteReg &HB0 + rchan% - 1, 0
END SUB

SUB closechannels
FOR channel% = 0 TO 3
 WriteReg &HB0 + channel%, 0
NEXT
FOR channel% = 4 TO 9
 WriteReg &HB0 + channel% + 6, 0
NEXT
END SUB

DEFINT A-Z
SUB getblaster (DMA%, baseport%, IRQ%)
' This subroutine parses the BLASTER environment string and returns settings.
IF LEN(ENVIRON$("BLASTER")) = 0 THEN PRINT "BLASTER environment variable not set.": SYSTEM
FOR length% = 1 TO LEN(ENVIRON$("BLASTER"))
   SELECT CASE MID$(ENVIRON$("BLASTER"), length%, 1)
      CASE "A"
        baseport% = VAL("&H" + MID$(ENVIRON$("BLASTER"), length% + 1, 3))
      CASE "I"
        IRQ% = VAL(MID$(ENVIRON$("BLASTER"), length% + 1, 1))
      CASE "D"
        DMA% = VAL(MID$(ENVIRON$("BLASTER"), length% + 1, 1))
   END SELECT
NEXT
PRINT "BLASTER found at &H" + HEX$(baseport%)
warte 1

END SUB

DEFSNG A-Z
FUNCTION getmaxch (name$)
maxchannel = 0
OPEN name$ FOR INPUT AS #1
DO
INPUT #1, pl$
IF LCASE$(LEFT$(pl$, 1)) = "w" THEN
a = VAL(RIGHT$(pl$, LEN(pl$) - 1))
IF a > maxchannel THEN maxchannel = a
END IF
LOOP UNTIL EOF(1)
CLOSE
a = 0
getmaxch = maxchannel
END FUNCTION

DEFINT A-Z
SUB initsongpos
FOR a = 1 TO maxchannel
songpos(a) = 0
NEXT a
END SUB

SUB loadmem (datei$)
maxchannel = getmaxch(datei$)
channel = maxchannel
channel2 = 9
ERASE songpos
initsongpos
loadsong datei$
END SUB

DEFSNG A-B, D-Z
SUB loadsong (name$)
CLOSE : OPEN name$ FOR INPUT AS #1
channel = 1: oktave = 4: speed1 = 200: ERASE songpos
initsongpos
DO
INPUT #1, pl$
pl$ = LCASE$(pl$)
b$ = LCASE$(LEFT$(pl$, 1))

IF b$ = "w" THEN
channel = VAL(RIGHT$(pl$, LEN(pl$) - 1))
END IF


IF LEFT$(pl$, 5) = "mmult" THEN
mmult% = VAL(RIGHT$(pl$, LEN(pl$) - 5))
setins channel
GOTO unten
END IF
IF LEFT$(pl$, 5) = "cmult" THEN
cmult% = VAL(RIGHT$(pl$, LEN(pl$) - 5))
setins channel
GOTO unten
END IF
IF LEFT$(pl$, 6) = "mlevel" THEN
mlevel% = VAL(RIGHT$(pl$, LEN(pl$) - 6))
setins channel
GOTO unten
END IF
IF LEFT$(pl$, 6) = "clevel" THEN
clevel% = VAL(RIGHT$(pl$, LEN(pl$) - 6))
setins channel
GOTO unten
END IF
IF LEFT$(pl$, 7) = "mattack" THEN
mattack% = VAL(RIGHT$(pl$, LEN(pl$) - 7))
setins channel
GOTO unten
END IF
IF LEFT$(pl$, 7) = "cattack" THEN
cattack% = VAL(RIGHT$(pl$, LEN(pl$) - 7))
setins channel
GOTO unten
END IF
IF LEFT$(pl$, 8) = "msustain" THEN
msustain% = VAL(RIGHT$(pl$, LEN(pl$) - 8))
setins channel
GOTO unten
END IF
IF LEFT$(pl$, 8) = "csustain" THEN
csustain% = VAL(RIGHT$(pl$, LEN(pl$) - 8))
setins channel
GOTO unten
END IF







IF b$ = "o" THEN
oktave = VAL(RIGHT$(pl$, LEN(pl$) - 1))
END IF

IF b$ = "l" THEN
speed1 = VAL(RIGHT$(pl$, LEN(pl$) - 1))
END IF

IF songpos(channel) = 0 THEN songpos(channel) = 1
IF b$ = "p" THEN
note(channel, songpos(channel)) = "P"
speed(channel, songpos(channel)) = CSNG(speed1 / 100)
oktave(channel, songpos(channel)) = oktave
songpos(channel) = songpos(channel) + 1
END IF
IF b$ = "c" THEN
note(channel, songpos(channel)) = "C"
speed(channel, songpos(channel)) = CSNG(speed1 / 100)
oktave(channel, songpos(channel)) = oktave
IF MID$(pl$, 2, 1) = "#" THEN note(channel, songpos(channel)) = "C#"
songpos(channel) = songpos(channel) + 1
END IF
IF b$ = "d" THEN
note(channel, songpos(channel)) = "D"
speed(channel, songpos(channel)) = CSNG(speed1 / 100)
oktave(channel, songpos(channel)) = oktave
IF MID$(pl$, 2, 1) = "#" THEN note(channel, songpos(channel)) = "D#"
songpos(channel) = songpos(channel) + 1
END IF
IF b$ = "e" THEN
note(channel, songpos(channel)) = "E"
speed(channel, songpos(channel)) = CSNG(speed1 / 100)
oktave(channel, songpos(channel)) = oktave
IF MID$(pl$, 2, 1) = "#" THEN note(channel, songpos(channel)) = "E#"
songpos(channel) = songpos(channel) + 1
END IF
IF b$ = "f" THEN
note(channel, songpos(channel)) = "F"
speed(channel, songpos(channel)) = CSNG(speed1 / 100)
oktave(channel, songpos(channel)) = oktave
IF MID$(pl$, 2, 1) = "#" THEN note(channel, songpos(channel)) = "F#"
songpos(channel) = songpos(channel) + 1
END IF
IF b$ = "g" THEN
note(channel, songpos(channel)) = "G"
speed(channel, songpos(channel)) = CSNG(speed1 / 100)
oktave(channel, songpos(channel)) = oktave
IF MID$(pl$, 2, 1) = "#" THEN note(channel, songpos(channel)) = "G#"
songpos(channel) = songpos(channel) + 1
END IF
IF b$ = "a" THEN
note(channel, songpos(channel)) = "A"
speed(channel, songpos(channel)) = CSNG(speed1 / 100)
oktave(channel, songpos(channel)) = oktave
IF MID$(pl$, 2, 1) = "#" THEN note(channel, songpos(channel)) = "A#"
songpos(channel) = songpos(channel) + 1
END IF
IF b$ = "b" THEN
note(channel, songpos(channel)) = "B"
speed(channel, songpos(channel)) = CSNG(speed1 / 100)
oktave(channel, songpos(channel)) = oktave
IF MID$(pl$, 2, 1) = "#" THEN note(channel, songpos(channel)) = "B#"
songpos(channel) = songpos(channel) + 1
END IF









maxnotes(channel) = songpos(channel) + 1
unten:
LOOP UNTIL EOF(1)
CLOSE
ERASE songpos
initsongpos
END SUB

DEFSNG C
SUB playnote (note$, channel%, oktave)
note$ = UCASE$(note$)
rchan% = channel% - 1
closechannel channel%
  
     SELECT CASE note$
       CASE "D"
         WriteReg &HA0 + rchan%, &H81
         WriteReg &HB0 + rchan%, &H21 + 4 * oktave
       CASE "E"
         WriteReg &HA0 + rchan%, &HB0
         WriteReg &HB0 + rchan%, &H21 + 4 * oktave
       CASE "F"
         WriteReg &HA0 + rchan%, &HCA
         WriteReg &HB0 + rchan%, &H21 + 4 * oktave
       CASE "G"
         WriteReg &HA0 + rchan%, &H2
         WriteReg &HB0 + rchan%, &H22 + 4 * oktave
       CASE "A"
         WriteReg &HA0 + rchan%, &H41
         WriteReg &HB0 + rchan%, &H22 + 4 * oktave
       CASE "B"
         WriteReg &HA0 + rchan%, &H87
         WriteReg &HB0 + rchan%, &H22 + 4 * oktave
       CASE "C"
         WriteReg &HA0 + rchan%, &HAE
         WriteReg &HB0 + rchan%, &H22 + 4 * (oktave - 1)
       CASE "C#"
         WriteReg &HA0 + rchan%, &H6B
         WriteReg &HB0 + rchan%, &H21 + 4 * oktave
       CASE "D#"
         WriteReg &HA0 + rchan%, &H98
         WriteReg &HB0 + rchan%, &H21 + 4 * oktave
       CASE "F#"
         WriteReg &HA0 + rchan%, &HE5
         WriteReg &HB0 + rchan%, &H21 + 4 * oktave
       CASE "G#"
         WriteReg &HA0 + rchan%, &H20
         WriteReg &HB0 + rchan%, &H22 + 4 * oktave
       CASE "A#"
         WriteReg &HA0 + rchan%, &H63
         WriteReg &HB0 + rchan%, &H22 + 4 * oktave
       
       CASE "WAVE"
         'ndert die WAVEFORM
         WriteReg &HE0 + rchan%, waveform%
     END SELECT
'


END SUB

SUB playsong
IF playing = 1 THEN
hj = 0
FOR a = 1 TO maxchannel
IF songpos(a) + 1 > maxnotes(a) THEN
hj = hj + 1: IF hj = maxchannel THEN playing = 0
GOTO unten2
END IF


q = TIME(a, songpos(a) + 1)




IF q = 0 OR TIMER >= q THEN
IF note(a, songpos(a) + 1) = "P" THEN
closechannel (a)
ELSE
playnote RTRIM$(note(a, songpos(a) + 1)), INT(a), INT(oktave(a, songpos(a) + 1))
END IF

songpos(a) = songpos(a) + 1
TIME(a, songpos(a) + 1) = TIMER + speed(a, songpos(a))


END IF
unten2:
NEXT a
END IF
END SUB

SUB sbinit
   FOR z% = 1 TO &HF5
     WriteReg z%, 0
   NEXT z%
END SUB

SUB setins (achannel%)

channel% = achannel% - 1
CarChan% = channel%
ModChan% = channel%

IF channel% >= 3 THEN
 CarChan% = CarChan% + 5
 ModChan% = ModChan% + 5
END IF

IF channel% >= 6 THEN
 CarChan% = CarChan% + 5
 ModChan% = ModChan% + 5
END IF


WriteReg &H20 + CarChan%, cmult%  'Plays carrier note at specified oktave ch. 1
WriteReg &H23 + ModChan%, mmult%  'Plays modulator note at specified oktave ch. 1
WriteReg &H40 + CarChan%, clevel%   'Set carrier total level to softest ch. 1
WriteReg &H43 + ModChan%, mlevel%   'Set modulator level to loudest ch. 1
WriteReg &H60 + CarChan%, cattack%  'Set carrier attack and decay ch. 1
WriteReg &H63 + ModChan%, mattack% 'Set modulator attack and decay ch. 1
WriteReg &H80 + CarChan%, csustain% 'Set carrier sustain and release ch. 1
WriteReg &H83 + ModChan%, msustain% 'Set modulator sustain and release ch. 1
END SUB

DEFINT A-Z
' Wartet, bis p# Sekunden vergangen sind.
SUB warte (p#)

  t# = TIMER
  IF t# + p# >= 86399.9 THEN                    ' Um 00:00 Uhr wird TIMER
    DO: LOOP WHILE TIMER > 86300                ' auf 0 zurckgesetzt.
    t# = TIMER                                  ' Das hier ist nur fr
  END IF                                        ' den Fall, da...
  DO WHILE TIMER < t# + p#: LOOP

END SUB

SUB WriteReg (Reg%, value%)
baseport2% = baseport%
OUT baseport2% + 8, Reg%
 FOR V% = 1 TO 6
  baseport2% = baseport%
  buf% = INP(baseport2% + 8)
 NEXT
baseport2% = baseport%
OUT baseport2% + 9, value%
 FOR V% = 1 TO 34
  baseport2% = baseport%
  buf% = INP(baseport2% + 9)
 NEXT


END SUB

